program PavageCarresTrianglesCercles;
 uses Robot1, Robot2, Robot3, Robot4, Robot5;

 {*******************************************************}
 {*                                                     *}
 {* "Premires leons de programmation en Turbo Pascal" *}
 {* Patrick, Laurent, Radhia et Thibault COUSOT         *}
 {* ditions McGraw-Hill, Paris, 1991.                  *}
 {* Pavage de carrs, triangles et cercles, page 78 et  *}
 {* PavageCarresTrianglesCercles, page 83.              *}
 {*                                                     *}
 {*******************************************************}

 procedure Carre;
  { Dessiner un carr de ct de taille 2, le robot partant du coin }
  { infrieur  gauche tourn vers l'est, et arrivant crayon baiss  }
  { au coin infrieur droit galement orient  l'est.              }
 begin
  { Dessiner le carr.                                              }
  av; av; pqtg; av; av; pqtg; av; av; pqtg; av; av; pqtg;
  { Avancer au coin infrieur droit.                                }
  av; av; 
 end;
 
 procedure Triangles;
  { Dessiner  deux triangles opposs par un sommet inscrits dans un }
  { carr invisible du quadrillage de ct 2, en  partant  du  coin }
  { infrieur  gauche du carr tourn vers l'est, et en arrivant au }
  { coin infrieur droit, crayon baiss et tourn vers l'est.       }
 begin
  lc; av; bc;
  pqtg; av; av; p3htg; av; p3htg; av; av; p3htd; av; p3htg;
  lc; av; bc; 
 end;
 
 procedure Cercle;
  { Dessiner  un  cercle de rayon 1 inscrit dans un carr invisible }
  { du quadrillage de ct 2, en partant du coin  infrieur  gauche }
  { du  carr  tourn  vers l'est, et en arrivant au coin infrieur }
  { droit du carr, crayon baiss et tourn vers l'est.             }
 begin 
  lc; av; bc; 
  vg; vg; vg; vg; 
  lc; av; bc; 
 end;
 
 procedure LigneCarre;
 { Dessiner une ligne constitue d'un motif rpt 7 fois, le motif }
 { tant  form d'un carr, de triangles et d'un cercle juxtaposs, }
 { le robot partant du coin infrieur gauche de  la  ligne  orient }
 { vers l'est, et arrivant au coin infrieur droit galement orien- }
 { t  l'est.                                                      }
  var I : integer;
 begin
  for I := 1 to 7 do
   begin
    { Le robot est crayon baiss,  l'est, en bas  gauche du motif }
    Carre; Triangles; Cercle; 
   end;
 end;
 
 procedure LigneTriangles;
 { Dessiner une ligne constitue d'un motif rpt 7 fois, le motif }
 { tant  form de triangles, d'un cercle et d'un carr juxtaposs, }
 { le robot partant du coin infrieur gauche de  la  ligne  orient }
 { vers l'est, et arrivant au coin infrieur droit galement orien- }
 { t  l'est.                                                      }
  var I : integer;
 begin
  for I := 1 to 7 do
   begin
    { Le robot est crayon baiss,  l'est, en bas  gauche du motif }
    Triangles; Cercle; Carre; 
   end;
 end;
 
 procedure LigneCercle;
 { Dessiner une ligne constitue d'un motif rpt 7 fois, le motif }
 { tant  form d'un cercle, de triangles et d'un carr juxtaposs, }
 { le robot partant du coin infrieur gauche de  la  ligne  orient }
 { vers l'est, et arrivant au coin infrieur droit galement orien- }
 { t  l'est.                                                      }
  var I : integer;
 begin
  for I := 1 to 7 do
   begin 
   { Le robot est crayon baiss,  l'est, en bas  gauche du motif }
    Cercle; Carre; Triangles; 
   end;
 end;
 
 procedure AlaLigne;
  { Ramener  le  robot  du coin infrieur droit d'une ligne au coin }
  { infrieur gauche de la ligne suivante sans  changer  l'orienta- }
  { tion  du  robot  l'est, sans dessiner et en baissant le crayon }
  { au dbut de la ligne suivante.                                  }
 begin
  lc; ag; pqtd; av; av; pqtg; bc;
 end;
 
 procedure Pavage;
  { Paver  l'cran  de  11 lignes commenant par un carr, puis par }
  { des triangles puis par un cercle constitues de motifs  rpti- }
  { tifs forms d'un carr suivi d'un cercle et de triangles juxta- }
  { poss en partant du coin suprieur droit et en arrivant au coin }
  { infrieur droit de l'cran, avec le robot tourn vers l'est.    }
  var J : integer;
 begin
  { Dessiner les lignes 1  9 de haut en bas.                       }
  for J := 1 to 3 do
   begin
    AlaLigne; LigneCarre;
    AlaLigne; LigneTriangles;
    AlaLigne; LigneCercle;
   end;
  { Dessiner les lignes 10 puis 11.                                 }
  AlaLigne; LigneCarre;
  AlaLigne; LigneTriangles;
end;
 
begin
 { Placer le robot au coin suprieur droit orient vers l'est.      }
 eh; ad; pqtd;
 { Paver l'cran, terminer au coin infrieur droit orient  l'est. }
 Pavage; st; 
end.